
# FIXME, currently incompat with nm >= 0.7
%define _without_nm -DWITH_NetworkManager=off

Summary: K Desktop Environment - Workspace
Name: kdebase-workspace
Version: 4.0.3

Release: 20%{?dist}
Source0: ftp://ftp.kde.org/pub/kde/stable/%{version}/src/kdebase-workspace-%{version}.tar.bz2
License: GPLv2
Group: User Interface/Desktops
URL: http://www.kde.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch1: kdebase-workspace-4.0.3-redhat-startkde.patch
Patch2: kdebase-workspace-4.0.0-consolekit-kdm.patch
Patch3: kdebase-workspace-4.0.2-plasma-konsole.patch
Patch4: kdebase-workspace-4.0.2-onlyshowkde.patch
Patch5: kdebase-workspace-4.0.3-ck-shutdown.patch
# 434824: KDE4 System Settings - No Method To Enter Administrative Mode
Patch6: kdebase-workspace-4.0.3-rootprivs.patch
Patch7: kdebase-workspace-4.0.3-timedate-kcm.patch
# 441062: packagekit tools do not show icons correctly on KDE
Patch8: kdebase-workspace-4.0.3-krdb.patch
Patch9: kdebase-workspace-4.0.3-suspend.patch

# upstream patches:
# http://bugs.kde.org/155362 (show Name in addition to GenericName in simple menu)
# backported from trunk (KDE 4.1): http://websvn.kde.org/?view=rev&revision=762886
# This has been merged into 4.0.3 in http://websvn.kde.org/?view=rev&revision=790059
# and the config parts reverted in http://websvn.kde.org/?view=rev&revision=790454
# due to new strings. This patch reverts rev 790454 and restores the full backport.
Patch100: kdebase-workspace-4.0.3-kde#155362.patch
# backport of http://websvn.kde.org/?view=rev&revision=780495 from 4.1
# (fixed version of http://websvn.kde.org/?view=rev&revision=790063
# which was reverted in http://websvn.kde.org/?view=rev&revision=790104)
Patch101: kdebase-workspace-4.0.3-menu-switch.patch

# plasma-4.0-openSUSE patches:
# http://websvn.kde.org/?view=rev&revision=795438
# allows to define a default wallpaper via plasmarc:wallpaper
Patch200: kdebase-workspace-4.0.3-plasma-default-wallpaper.patch
# http://websvn.kde.org/?view=rev&revision=791852
# from Plasma review board: http://mattr.info/r/261/
# allows moving plasmoids on panels (#439587, kde#158301)
Patch201: kdebase-workspace-4.0.3-kde#158301.patch
# http://websvn.kde.org/?view=rev&revision=794496
# don't show "Zoom Out" toolbox action (not working in 4.0)
Patch202: kdebase-workspace-4.0.3-rh#443610.patch
# #444141: Initial wallpaper chooser has "EOS" preselected but wallpaper is "Fedora Waves"
# http://websvn.kde.org/?view=rev&revision=801651
Patch203: kdebase-workspace-4.0.3-plasma-default-wallpaper-config.patch

# upgrade path for former kde-redhat'ers
Obsoletes: kdebase-kdm < 6:%{version}-%{release}
Provides: kdebase-kdm = 6:%{version}-%{release}

# upgrade path: kdebase(3) -> kdebase-workspace
Obsoletes: kdebase < 6:4
# so kdebase doesn't get lost on kde3->kde4 upgrade (#444928)
Requires: kdebase4

# kdmtheme's functionality is now provided by kdebase-workspace itself
Obsoletes: kdmtheme < 1.3

BuildRequires: bluez-libs-devel
BuildRequires: cmake
BuildRequires: dbus-devel
BuildRequires: glib2-devel
BuildRequires: kde-filesystem >= 4
BuildRequires: kdelibs4-devel >= %{version}
BuildRequires: libraw1394-devel
BuildRequires: libxklavier-devel
BuildRequires: libXres-devel
BuildRequires: lm_sensors-devel
%{!?_without_nm:BuildRequires: NetworkManager-devel}
BuildRequires: pam-devel
BuildRequires: qimageblitz-devel

Requires: %{name}-libs = %{version}-%{release}
Requires: kde-settings-kdm
%{?_kde4_macros_api:Requires: kde4-macros(api) = %{_kde4_macros_api} }
Requires(post): xdg-utils
Requires(postun): xdg-utils

# would much rather these deps be elsewhere, 
# but adding here doesn't hurt either -- Rex
Requires: kdebase-runtime >= %{version}
Requires: oxygen-icon-theme

# startkde references: dbus-launch df mkdir test xmessage xprop xrandr xrdb xset xsetroot
Requires: coreutils
Requires: dbus-x11
Requires: xorg-x11-apps
Requires: xorg-x11-utils
Requires: xorg-x11-server-utils

%description
The KDE Workspace consists of what is the desktop of the 
KDE Desktop Environment.

This package contains:
* kdm (the login manager of KDE)
* khotkeys (a hotkey daemon)
* klipper (a cut & paste history utility)
* kmenuedit (the menu editor)
* krandrtray (resize and rotate X screens)
* krunner (a command run interface)
* ksysguard (a performance monitor)
* kwin (the window manager of KDE)
* kxkb (a utility to switch keyboard maps)
* plasma (the KDE desktop, panels and widgets workspace application)
* systemsettings (the configuration editor)

%package devel
Group:    Development/Libraries
Summary:  Development files for %{name}
Requires: %{name}-libs = %{version}-%{release}
Requires: kdelibs4-devel
%description devel
%{summary}.

%package libs
Summary: Runtime libraries for %{name}
Group:   System Environment/Libraries
Requires: kdelibs4 >= %{version}
# out of paranoia really, may or may not be 100% essential.  -- Rex
Requires: %{name} = %{version}-%{release}
%description libs
%{summary}.


%prep

%setup -q

# RH/Fedora-specific startkde changes
%patch1 -p1 -b .redhat-startkde
# ConsoleKit support for KDM (#228111, kde#147790)
%patch2 -p1 -b .consolekit
%patch3 -p1 -b .plasma-konsole
%patch4 -p1 -b .onlyshowkde
# ConsoleKit >= 0.2.4 shutdown/reboot support (needed for GDM 2.22)
%patch5 -p1 -b .ck-shutdown
%patch6 -p0 -b .rootprivs
%patch7 -p0 -b .timedate-kcm
%patch8 -p0 -b .krdb
%patch9 -p1 -b .suspend

# upstream patches
%patch101 -p1 -b .menu-switch
%patch100 -p0 -b .kde#155362

# plasma-4.0-openSUSE patches:
%patch200 -p0 -b .plasma-default-wallpaper
%patch201 -p1 -b .kde#158301
%patch202 -p1 -b .rh#443610
%patch203 -p0 -b .plasma-default-wallpaper-config

%build

mkdir -p %{_target_platform}
pushd %{_target_platform}
%{cmake_kde4} %{?_without_nm} \
  -DKDE4_KDM_PAM_SERVICE=kdm \
  -DKDE4_KCHECKPASS_PAM_SERVICE=kcheckpass \
  -DKDE4_KSCREENSAVER_PAM_SERVICE=kscreensaver ..
popd

make %{?_smp_mflags} -C %{_target_platform}


%install
rm -rf %{buildroot}

make install DESTDIR=%{buildroot} -C %{_target_platform}

# xsession support
mkdir -p %{buildroot}%{_datadir}/xsessions/
ln -s %{_kde4_appsdir}/kdm/sessions/kde.desktop %{buildroot}%{_datadir}/xsessions/kde.desktop

# FIXME/TODO: provide kdm config in kde-settings(-kdm)
# nuke, use external kde-config-kdm
rm -rf  %{buildroot}%{_kde4_configdir}/kdm

# own %{_kde4_appsdir}/kdm/faces and set default user image
mkdir -p %{buildroot}%{_kde4_appsdir}/kdm/faces
pushd %{buildroot}%{_kde4_appsdir}/kdm/faces
ln -sf ../pics/users/default1.png .default.face.icon
popd

# move devel symlinks
mkdir -p %{buildroot}%{_kde4_libdir}/kde4/devel
pushd %{buildroot}%{_kde4_libdir}
for i in lib*.so
do
  case "$i" in
    libkdeinit*.so)
      ;;
    # leave libworkspace.so for kate
    libkworkspace.so|libplasma.so)
      linktarget=`readlink "$i"`
      ln -sf "../../$linktarget" "kde4/devel/$i"
      ;;
    *)
      linktarget=`readlink "$i"`
      rm -f "$i"
      ln -sf "../../$linktarget" "kde4/devel/$i"
      ;;
  esac
done
popd


%clean
rm -rf %{buildroot}


%post
xdg-icon-resource forceupdate --theme oxygen 2> /dev/null || :
xdg-icon-resource forceupdate --theme hicolor 2> /dev/null || :
xdg-desktop-menu forceupdate 2> /dev/null || :

%postun
xdg-icon-resource forceupdate --theme oxygen 2> /dev/null || :
xdg-icon-resource forceupdate --theme hicolor 2> /dev/null || :
xdg-desktop-menu forceupdate 2> /dev/null || :

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc COPYING README
%config(noreplace) %{_kde4_sysconfdir}/ksysguarddrc
# FIXME/TODO: Consider %config(noreplace)
%config %{_kde4_sysconfdir}/systemsettingsrc
%{_kde4_bindir}/*
%{_kde4_appsdir}/*
%{_kde4_configdir}/*
%{_kde4_datadir}/kde4/services/*
%{_kde4_datadir}/kde4/servicetypes/*
%{_kde4_datadir}/wallpapers/*
%{_kde4_datadir}/sounds/*
%{_kde4_datadir}/desktop-directories/*
%{_kde4_datadir}/autostart/*
%{_kde4_datadir}/applications/kde4/*
%{_datadir}/dbus-1/interfaces/*
%{_kde4_datadir}/config.kcfg/*
%{_datadir}/xsessions/*
%{_kde4_docdir}/HTML/en/*
%{_kde4_iconsdir}/oxygen/*/*/*
%{_kde4_iconsdir}/hicolor/*/*/*
%{_kde4_libdir}/kde4/*.so
%{_kde4_libexecdir}/*

%{_libdir}/strigi/
%{_kde4_libdir}/libkdeinit*.so
%{_kde4_libdir}/kconf_update_bin/*

%files libs
%defattr(-,root,root,-)
%{_kde4_libdir}/lib*.so.*

%files devel
%defattr(-,root,root,-)
%{_kde4_includedir}/*
%{_kde4_libdir}/lib*.so
%{_kde4_libdir}/kde4/devel/lib*.so
%{_kde4_libdir}/kde4/plugins/designer/ksysguardwidgets.so
%exclude %{_kde4_libdir}/libkdeinit*.so


%changelog
* Fri May 02 2008 Rex Dieter <rdieter@fedoraproject.org> 4.0.3-20
- Requires: kdebase , so it doesn't go missing on upgrades from kde3 (#444928)

* Mon Apr 28 2008 Lukáš Tinkl <ltinkl@redhat.com> 4.0.3-19
- #444141: Initial wallpaper chooser has "EOS" preselected but wallpaper is "Fedora Waves"

* Sun Apr 27 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-18
- don't show "Zoom Out" toolbox action (#443610, patch from openSUSE branch)

* Sat Apr 19 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-17
- allow moving plasmoids on panels (#439587, kde#158301) (upstream patch)

* Fri Apr 18 2008 Than Ngo <than@redhat.com> 4.0.3-16
- fix #442559, Suspend/Hibernate issue on logout

* Tue Apr 15 2008 Lukáš Tinkl <ltinkl@redhat.com> 4.0.3-15
- workaround #434824: KDE4 System Settings - No Method To Enter Administrative Mode
- fix #441062: packagekit tools do not show icons correctly on KDE

* Tue Apr 15 2008 Sebastian Vahl <fedora@deadbabylon.de> 4.0.3-13
- update redhat-startkde.patch to match waves background color (#442312)

* Fri Apr 11 2008 Lukáš Tinkl <ltinkl@redhat.com> 4.0.3-12
- allow to define a default wallpaper (plasmarc:wallpaper)

* Wed Apr 09 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-11
- read the default KSplash theme from kde-settings in startkde (#441565)

* Mon Apr 07 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-7
- own %%{_kde4_appsdir}/kdm/faces and set default user image (#441154)

* Thu Apr 03 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-6
- rebuild for the fixed %%{_kde4_buildtype}

* Mon Mar 31 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-5
- update file list for _kde4_libexecdir

* Mon Mar 31 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-4
- backport context menu switch between Kickoff and simple menu from 4.1

* Sat Mar 29 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-3
- add support for shutdown/reboot through ConsoleKit >= 0.2.4 (#431817)

* Fri Mar 28 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.3-2
- most of the kde#155362 patch has been merged, keep only the config part

* Fri Mar 28 2008 Than Ngo <than@redhat.com> 4.0.3-1
- 4.0.3

* Fri Mar 28 2008 Than Ngo <than@redhat.com> 4.0.2-9
- add onlyshowin=KDE for systemsetting

* Thu Mar 13 2008 Than Ngo <than@redhat.com> 4.0.2-8
- backport upstream patch to fix crash in kmenuedit when users
  delete entry and save it

* Wed Mar 12 2008 Than Ngo <than@redhat.com> 4.0.2-7
- apply upstream patch to fix changing wallpaper causes desktop to go white
- apply upstream patch to check whether the to-be-embedded window has been destroyed, (bz#437058)

* Mon Mar 10 2008 Than Ngo <than@redhat.com> 4.0.2-6
- add gestures=false in kde-settings, remove kdebase-workspace-4.0.2-Gestures.patch

* Thu Mar 06 2008 Than Ngo <than@redhat.com> 4.0.2-5
- typo fix

* Tue Mar 04 2008 Than Ngo <than@redhat.com> 4.0.2-4
- disable gestures as default
- add konsole in desktop menu

* Mon Mar 03 2008 Than Ngo <than@redhat.com> 4.0.2-3
- apply upstream patch to fix crash in khotkeys

* Fri Feb 29 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.2-2
- drop upstreamed kde#155974 patch
- update kde#155362 patch

* Thu Feb 28 2008 Than Ngo <than@redhat.com> 4.0.2-1
- 4.0.2

* Mon Feb 25 2008 Rex Dieter <rdieter@fedoraproject.org> 4.0.1-8
- %%files: don't own %%_kde4_libdir/kde4/plugins (thanks wolfy!)

* Sat Feb 16 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.1-7
- omit broken disk space checking hunk from redhat-startkde patch (#426871)

* Wed Feb 06 2008 Rex Dieter <rdieter@fedoraproject.org> 4.0.1-6
- revert Conflicts, it matches against Provides from kdelibs3.

* Wed Feb 06 2008 Rex Dieter <rdieter@fedoraproject.org> 4.0.1-5
- Conflicts: kdelibs < 6:4 (temporary, to ease upgrade pain)
- -devel: Requires: %%name-libs

* Mon Feb 04 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.1-4
- backport enhancement to allow multi-line taskbar from 4.1 (kde#155974)

* Mon Feb 04 2008 Than Ngo <than@redhat.com> 4.0.1-3
- respin

* Fri Feb 01 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.1-2
- update kde#155362 (simple menu) patch for 4.0.1 (thanks to Jan Mette)

* Wed Jan 30 2008 Rex Dieter <rdieter@fedoraproject.org> 4.0.1-1
- 4.0.1

* Wed Jan 30 2008 Rex Dieter <rdieter@fedoraproject.org> 4.0.0-8
- respin (qt4)

* Sat Jan 26 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.0-7
- backport simple menu enhancement to show .desktop Name from 4.1 (kde#155362)

* Wed Jan 23 2008 Rex Dieter <rdieter@fedoraproject.org> 4.0.0-6
- Obsoletes: kdebase < 6:4

* Wed Jan 09 2008 Rex Dieter <rdieter[AT]fedoraproject.org> 4.0.0-5
- initial login with white background (#428131, kde#155122)

* Wed Jan 09 2008 Rex Dieter <rdieter[AT]fedoraproject.org> 4.0.0-4
- use upstream systemtray patch (#427442, kde#153193)

* Tue Jan 08 2008 Rex Dieter <rdieter[AT]fedoraproject.org> 4.0.0-3
- respun tarball
- omit gtk_applet patch (for now, doesn't build)

* Tue Jan 08 2008 Rex Dieter <rdieter[AT]fedoraproject.org> 4.0.0-2
- omit plasma-pager patch
- pull upstream patch to workaround gtk applet crasher (#427442)

* Mon Jan 07 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.0.0-1
- update to 4.0.0
- drop upstreamed creategtkrc-gtk212 patch
- update redhat-startkde and consolekit-kdm patches

* Mon Dec 31 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> - 3.97.0-5
- fix createGtkrc to set tooltip colors also for GTK+ 2.12+

* Sun Dec 30 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.97.0-4
- Obsoletes: kdmtheme

* Mon Dec 17 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.97.0-3
- Requires: coreutils dbus-x11 xorg-x11-apps xorg-x11-utils 
            xorg-x11-server-utils (used in startkde)
- drop pam configs that were previously moved to kde-settings

* Tue Dec 11 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.97.0-2
- rebuild for changed _kde4_includedir

* Wed Dec 05 2007 Rex Dieter <rdieter[AT]fedoraprojec.torg. 3.97.0-1
- kde-3.97.0
- move pam configs to kde-settings
- Requires: kde-settings-kdm

* Tue Dec 04 2007 Than Ngo <than@redhat.com> 3.96.2-3
- fix kdm/kcheckpass/kscreensaver to get working

* Sat Dec 01 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.2-2
- BR: dbus-devel
- crystalsvg icons are not part of kdebase-workspace anymore
- make sure libkdeinit_plasma.so is in normal package

* Sat Dec 01 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.96.2-1
- kde-3.96.2

* Sat Dec 01 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.96.1-4
- Obsoletes and Provides kdebase-kdm for upgrades from old kde-redhat

* Fri Nov 30 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.96.1-3
- update and apply redhat-startkde patch
- update and apply KDM ConsoleKit patch (#228111, kde#147790)
- ConsoleKit patch also includes xdmcp fixes from Mandriva (#243560)

* Wed Nov 28 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.96.1-2
- %%doc README COPYING
- -libs subpkg
- -libs: Requires: kdelibs4
- don't remove libplasma.so from %%{_kde4_libdir}
- %%files: use %%_datadir for dbus-1/interfaces,xsessions

* Mon Nov 19 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.1-1
- kde-3.96.1

* Mon Nov 19 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.0-7
- use kde.desktop from /usr/share/apps/kdm/sessions/kde.desktop
- use %%config(noreplace) for /etc/ksysguarddrc
- Requires: kdebase, kdebase-runtime, oxygen-icon-theme
- fix url

* Mon Nov 19 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.0-6
- add patch to get pager in plasma bar
- re-added BR: libraw1394-devel

* Mon Nov 19 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.0-5
- leave libkworkspace.so for kate
- BR: kde-filesystem >= 4

* Mon Nov 19 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.0-4
- BR: libXtst-devel
- BR: libXScrnSaver-devel

* Fri Nov 15 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.0-3
- own some more directories
- add %%defattr to package devel
- some spec cleanups
- -R: kdepimlibs-devel
- +BR: libXpm-devel
- +BR: glib2-devel (do we really need this?)

* Thu Nov 15 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.0-2
- BR: libXxf86misc-devel
- BR: libXxf86misc-devel
- BR: libXcomposite-devel
- BR: bluez-libs-devel
- BR: libxklavier-devel
- BR: pam-devel
- BR: lm_sensors-devel
- BR: libXdamage-devel
- BR: libXv-devel
- BR: libXres-devel

* Wed Nov 14 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.96.0-1
- kde-3.96.0

* Wed Nov 14 2007 Sebastian Vahl <fedora@deadbabylon.de> 3.95.2-1
- Initial version of kdebase-workspace
